/*
ID: espr1t
TASK: Rotating Maze
KEYWORDS: Hard, Cyclic DP, Probability
*/

#include <cstdio>
#include <cstring>

using namespace std;
FILE* in = stdin; FILE* out = stdout;

const int MAX = 1024;

int n, m;
int a[MAX][MAX];
double dyn[MAX][MAX];

// Probability to move both ways, when on boundary row or column
double b1[2][2] = {{0.25, 0.50}, {0.50, 1.00}};
// Probability to move right, when not on boundary row or column
double r2[2][2][2] = {{{0.25, 0.25}, {0.50, 0.50}}, {{0.375, 0.25}, {0.75, 0.50}}};
// Probability to move down, when not on boundary row or column
double d2[2][2][2] = {{{0.25, 0.50}, {0.25, 0.50}}, {{0.375, 0.75}, {0.25, 0.50}}};


double recurse(int row, int col) {
    if (row == n - 1 && col == m - 1)
        return 0.0;
    if (dyn[row][col] == dyn[row][col])
        return dyn[row][col];
    
    double chanceR = r2[a[row][col]][a[row][col + 1]][a[row + 1][col]];
    double chanceD = d2[a[row][col]][a[row][col + 1]][a[row + 1][col]];
    if (row == n - 1)
        chanceR = b1[a[row][col]][a[row][col + 1]], chanceD = 0.0;
    if (col == m - 1)
        chanceD = b1[a[row][col]][a[row + 1][col]], chanceR = 0.0;
    
    double ans = 0.0;
    ans += chanceR > 0.0 ? chanceR * recurse(row, col + 1) : 0.0;
    ans += chanceD > 0.0 ? chanceD * recurse(row + 1, col) : 0.0;
    ans = (1.0 + ans) / (chanceR + chanceD);

    return dyn[row][col] = ans;
}

int main(void) {
//    in = fopen("RotatingMaze.in", "rt");
    
    fscanf(in, "%d %d", &n, &m);
    for (int row = 0; row < n; row++) {
        char line[MAX];
        fscanf(in, "%s", line);
        for (int col = 0; col < m; col++)
            a[row][col] = (line[col] == '+');
    }

    memset(dyn, -1, sizeof(dyn));
    fprintf(out, "%.6lf\n", recurse(0, 0));
    return 0;
}
